#ifndef ESP32_STORAGE_HPP
#define ESP32_STORAGE_HPP

#ifdef ESP32
#include "Preferences.h"
#include "SPIFFS.h"
#endif

#include "Utils.hpp"

namespace fw
{
    class Storage
    {
    private:
#ifdef ESP32
        Preferences memory;
#endif
        ok_t mount_spiffs();

    protected:
        uint8_t retrieve_settings_value(const char *);
        void store_settings_value(const char *, const uint8_t);

        firewall_rule_t *retrieve_firewall_rule(const uint8_t);
        void store_all_firewall_rules(firewall_rule_t *);
        void store_firewall_rule(firewall_rule_t *);

        // httpsserver::SSLCert *retrieve_certificate();
        // void store_certificate(httpsserver::SSLCert *);

    public:
        Storage();
        ~Storage();
    };
}

#endif
